tests: limit usertime and filesize with ulimit
[nit.git] / tests / tests.sh
1 #!/bin/bash
2 # This file is part of NIT ( http://www.nitlanguage.org ).
3 #
4 # Copyright 2004-2008 Jean Privat <jean@pryen.org>
5 #
6 # Licensed under the Apache License, Version 2.0 (the "License");
7 # you may not use this file except in compliance with the License.
8 # You may obtain a copy of the License at
9 #
10 # http://www.apache.org/licenses/LICENSE-2.0
11 #
12 # Unless required by applicable law or agreed to in writing, software
13 # distributed under the License is distributed on an "AS IS" BASIS,
14 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
15 # See the License for the specific language governing permissions and
16 # limitations under the License.
17
18 # This shell script compile, run and verify Nit program files
19
20 # Set lang do default to avoid failed tests because of locale
21 export LANG=C
22 export LC_ALL=C
23 export NIT_TESTING=true
24 export NIT_SRAND=0
25
26 unset NIT_DIR
27
28 # Get the first Java lib available
29 shopt -s nullglob
30 JAVA_HOME=$(dirname $(dirname $(readlink -f $(which javac))))
31
32 paths=`echo $JAVA_HOME/jre/lib/*/{client,server}/libjvm.so`
33 paths=($paths)
34 JNI_LIB_PATH=`dirname ${paths[0]}`
35 shopt -u nullglob
36
37 outdir="out"
38 compdir="nit_compile"
39
40 # User CPU time limit (in seconds)
41 # Is used to avoid to CPU intensive test (infinite loops). See ulimit -t
42 usertimelimit=600 # 1 CPU minute
43
44 # Real-time limit (in seconds)
45 # Is used to avoid waiting or sleeping tests.
46 # Require timeout or timelimit, or else is not used.
47 realtimelimit=300 # 5 min
48
49 # User limit for write files (in kilo-bytes)
50 # Is used to avoid execution that loop and fill the hard drive. See ulimit -f
51 # Note that a test might require a lot of temporary disk space (eg. nitc+gcc)
52 filelimit=100000 # ~100MB
53
54 # Limit (in bytes) for generated .res file.
55 # Larger ones are truncated and will fail tests
56 # Is used to avoid processing huge crappy res file (diff, xml, etc)
57 reslimit=100000 # ~100KB
58
59 usage()
60 {
61 e=`basename "$0"`
62 cat<<END
63 Usage: $e [options] modulenames
64 -o option Pass option to the engine
65 -v Verbose (show tests steps)
66 -h This help
67 --engine Use a specific engine (default=nitc)
68 --noskip Do not skip a test even if the .skip file matches
69 --outdir Use a specific output folder (default=out/)
70 --compdir Use a specific temporary compilation folder (default=$compdir)
71 --node Run as a node in parallel, will not output context information
72 --autosav Copy the .res files directly in the sav folder overriding existing .res files
73 END
74 }
75
76 # Run a command with a timeout and a time count.
77 # Options:
78 # -o file write the user time into file (REQUIRED). see `-o` in `man time`
79 # -a append the time to the file (instead of overwriting it). see `-a` in `man time`
80 saferun()
81 {
82 local stop=false
83 local o=
84 local a=
85 while [ $stop = false ]; do
86 case "$1" in
87 -o) o="$2"; shift; shift;;
88 -a) a="-a"; shift;;
89 *) stop=true
90 esac
91 done
92 (
93 ulimit -f "$filelimit"
94 ulimit -t "$usertimelimit"
95 if test -d "$1"; then
96 find $1 | sort
97 elif test -n "$TIME"; then
98 $TIME -o "$o" $a $TIMEOUT "$@"
99 else
100 if test -n "$a"; then echo 0 >> "$o"; else echo 0 > "$o"; fi
101 $TIMEOUT "$@"
102 fi
103 )
104 }
105
106 # Output a timestamp attribute for XML, or an empty line
107 timestamp()
108 {
109 if test -n "$TIMESTAMP"; then
110 echo "timestamp='`$TIMESTAMP`'"
111 else
112 echo ""
113 fi
114
115 }
116
117 # Get platform specific commands ##########################
118
119 # Detect a working timeout
120 if sh -c "timelimit echo" 1>/dev/null 2>&1; then
121 TIMEOUT="timelimit -t $realtimelimit"
122 elif sh -c "timeout 1 echo" 1>/dev/null 2>&1; then
123 TIMEOUT="timeout ${realtimelimit}s"
124 else
125 echo "No timelimit or timeout command detected. Tests may hang :("
126 fi
127
128 # Detect a working time command
129 if env time --quiet -f%U true 2>/dev/null; then
130 TIME="env time --quiet -f%U"
131 elif env time -f%U true 2>/dev/null; then
132 TIME="env time -f%U"
133 else
134 TIME=
135 fi
136
137 # Detect a working date command
138 if date -Iseconds >/dev/null 2>&1; then
139 TIMESTAMP="date -Iseconds"
140 else
141 TIMESTAMP=
142 fi
143
144 # $1 is the pattern of the test
145 # $2 is the file to compare to
146 # the result is:
147 # 0: if the file to compare to do not exists
148 # 1: if the file match
149 # 2: if the file match with soso
150 # 3: if the file do not match
151 function compare_to_result()
152 {
153 local pattern="$1"
154 local sav="$2"
155 if [ ! -r "$sav" ]; then return 0; fi
156 test "`cat -- "$sav"`" = "UNDEFINED" && return 1
157 diff -u -- "$sav" "$outdir/$pattern.res" > "$outdir/$pattern.diff.sav.log"
158 if [ "$?" == 0 ]; then
159 return 1
160 fi
161 sed '/[Ww]arning/d;/[Ee]rror/d' "$outdir/$pattern.res" > "$outdir/$pattern.res2"
162 sed '/[Ww]arning/d;/[Ee]rror/d' "$sav" > "$outdir/$pattern.sav2"
163 grep '[Ee]rror' "$outdir/$pattern.res" >/dev/null && echo "Error" >> "$outdir/$pattern.res2"
164 grep '[Ee]rror' "$sav" >/dev/null && echo "Error" >> "$outdir/$pattern.sav2"
165 diff -u "$outdir/$pattern.sav2" "$outdir/$pattern.res2" > "$outdir/$pattern.diff.sav.log2"
166 if [ "$?" == 0 ]; then
167 return 2
168 else
169 return 3
170 fi
171 }
172
173 function xmlesc()
174 {
175 sed 's/&/\&amp;/g; s/</\&lt;/g; s/>/\&gt;/g; s/"/\&quot;/g; s/'"'"'/\&#39;/g'<<EOF
176 $*
177 EOF
178 }
179
180 # As argument: the pattern used for the file
181 function process_result()
182 {
183 # Result
184 pattern=$1
185 description=$2
186 pack=$3
187 SAV=""
188 NSAV=""
189 FIXME=""
190 NFIXME=""
191 SOSO=""
192 NSOSO=""
193 SOSOF=""
194 NSOSOF=""
195 OLD=""
196 LIST=""
197 FIRST=""
198
199 # Truncate too big res file
200 size=$(wc -c < "$outdir/$pattern.res")
201 if test -n "$reslimit" -a "$size" -gt "$reslimit"; then
202 # The most portable way to truncate a file is with Perl
203 perl -e "truncate \"$outdir/$pattern.res\", $reslimit;"
204 echo "***TRUNCATED***" >> "$outdir/$pattern.res"
205 fi
206
207 echo >>$xml "<testcase classname='`xmlesc "$pack"`' name='`xmlesc "$description"`' time='`cat -- "$outdir/$pattern.time.out"`' `timestamp`>"
208 #for sav in "sav/$engine/fixme/$pattern.res" "sav/$engine/$pattern.res" "sav/fixme/$pattern.res" "sav/$pattern.res" "sav/$pattern.sav"; do
209 for savdir in $savdirs; do
210 sav=$savdir/fixme/$pattern.res
211 compare_to_result "$pattern" "$sav"
212 case "$?" in
213 0)
214 ;; # no file
215 1)
216 OLD="$LIST"
217 FIXME="$sav"
218 LIST="$LIST $sav"
219 ;;
220 2)
221 if [ -z "$FIRST" ]; then
222 SOSOF="$sav"
223 FIRST="$sav"
224 fi
225 LIST="$LIST $sav"
226 ;;
227 3)
228 if [ -z "$FIRST" ]; then
229 NFIXME="$sav"
230 FIRST="$sav"
231 fi
232 LIST="$LIST $sav"
233 ;;
234 esac
235
236 sav=$savdir/$pattern.res
237 compare_to_result "$pattern" "$sav"
238 case "$?" in
239 0)
240 ;; # no file
241 1)
242 OLD="$LIST"
243 SAV="$sav"
244 LIST="$LIST $sav"
245 ;;
246 2)
247 if [ -z "$FIRST" ]; then
248 SOSO="$sav"
249 FIRST="$sav"
250 fi
251 LIST="$LIST $sav"
252 ;;
253 3)
254 if [ -z "$FIRST" ]; then
255 NSAV="$sav"
256 FIRST="$sav"
257 fi
258 LIST="$LIST $sav"
259 ;;
260 esac
261 done
262 OLD=`echo "$OLD" | sed -e 's/ */ /g' -e 's/^ //' -e 's/ $//'`
263 grep 'NOT YET IMPLEMENTED' "$outdir/$pattern.res" >/dev/null
264 NYI="$?"
265 if [ -n "$SAV" ]; then
266 if [ -n "$OLD" ]; then
267 echo "[*ok*] $outdir/$pattern.res $SAV - but $OLD remains!"
268 echo >>$xml "<error message='`xmlesc "ok $outdir/$pattern.res - but $OLD remains"`'/>"
269 remains="$remains $OLD"
270 test "$autosav" = "true" && rm "$OLD"
271 else
272 echo "[ok] $outdir/$pattern.res $SAV"
273 fi
274 ok="$ok $pattern"
275 elif [ -n "$FIXME" ]; then
276 if [ -n "$OLD" ]; then
277 echo "[*fixme*] $outdir/$pattern.res $FIXME - but $OLD remains!"
278 echo >>$xml "<error message='`xmlesc "ok $outdir/$pattern.res - but $OLD remains"`'/>"
279 remains="$remains $OLD"
280 test "$autosav" = "true" && rm "$OLD"
281 else
282 echo "[fixme] $outdir/$pattern.res $FIXME"
283 echo >>$xml "<skipped/>"
284 fi
285 todos="$todos $pattern"
286 elif [ "x$NYI" = "x0" ]; then
287 echo "[todo] $outdir/$pattern.res -> not yet implemented"
288 echo >>$xml "<skipped/>"
289 todos="$todos $pattern"
290 elif [ -n "$SOSO" ]; then
291 echo "[======= soso $outdir/$pattern.res $SOSO =======]"
292 echo >>$xml "<error message='`xmlesc "soso $outdir/$pattern.res $SOSO"`'/>"
293 echo >>$xml "<system-out><![CDATA["
294 cat -v -- "$outdir/$pattern.diff.sav.log" | head >>$xml -n 50
295 echo >>$xml "]]></system-out>"
296 nok="$nok $pattern"
297 echo "$ii" >> "$ERRLIST"
298 test "$autosav" = "true" && cp "$outdir/$pattern.res" "$SOSO"
299 elif [ -n "$SOSOF" ]; then
300 echo "[======= fixme soso $outdir/$pattern.res $SOSOF =======]"
301 echo >>$xml "<error message='`xmlesc "soso $outdir/$pattern.res $SOSO"`'/>"
302 echo >>$xml "<system-out><![CDATA["
303 cat -v -- "$outdir/$pattern.diff.sav.log" | head >>$xml -n 50
304 echo >>$xml "]]></system-out>"
305 nok="$nok $pattern"
306 echo "$ii" >> "$ERRLIST"
307 test "$autosav" = "true" && cp "$outdir/$pattern.res" && "$SOSO"
308 elif [ -n "$NSAV" ]; then
309 echo "[======= fail $outdir/$pattern.res $NSAV =======]"
310 echo >>$xml "<error message='`xmlesc "fail $outdir/$pattern.res $NSAV"`'/>"
311 echo >>$xml "<system-out><![CDATA["
312 cat -v -- "$outdir/$pattern.diff.sav.log" | head >>$xml -n 50
313 echo >>$xml "]]></system-out>"
314 nok="$nok $pattern"
315 echo "$ii" >> "$ERRLIST"
316 test "$autosav" = "true" && cp "$outdir/$pattern.res" "$NSAV"
317 elif [ -n "$NFIXME" ]; then
318 echo "[======= changed $outdir/$pattern.res $NFIXME ======]"
319 echo >>$xml "<error message='`xmlesc "changed $outdir/$pattern.res $NFIXME"`'/>"
320 echo >>$xml "<system-out><![CDATA["
321 cat -v -- "$outdir/$pattern.diff.sav.log" | head >>$xml -n 50
322 echo >>$xml "]]></system-out>"
323 nok="$nok $pattern"
324 echo "$ii" >> "$ERRLIST"
325 test "$autosav" = "true" && cp "$outdir/$pattern.res" "$NFIXME"
326 elif [ -s "$outdir/$pattern.res" ]; then
327 echo "[=== no sav ===] $outdir/$pattern.res is not empty"
328 echo >>$xml "<error message='no sav and not empty'/>"
329 echo >>$xml "<system-out><![CDATA["
330 cat -v >>$xml -- "$outdir/$pattern.res"
331 echo >>$xml "]]></system-out>"
332 nos="$nos $pattern"
333 echo "$ii" >> "$ERRLIST"
334 test "$autosav" = "true" && cp "$outdir/$pattern.res" "sav/"
335 else
336 # no sav but empty res
337 echo "[0k] $outdir/$pattern.res is empty"
338 ok="$ok $pattern"
339 fi
340 if test -s "$outdir/$pattern.cmp.err"; then
341 echo >>$xml "<system-err><![CDATA["
342 cat -v >>$xml -- "$outdir/$pattern.cmp.err"
343 echo >>$xml "]]></system-err>"
344 fi
345 echo >>$xml "</testcase>"
346 }
347
348 need_skip()
349 {
350 test "$noskip" = true && return 1
351 if echo "$1" | grep -f "$engine.skip" >/dev/null 2>&1; then
352 echo "=> $2: [skip]"
353 echo >>$xml "<testcase classname='`xmlesc "$3"`' name='`xmlesc "$2"`' `timestamp`><skipped/></testcase>"
354 return 0
355 fi
356 if test -n "$isinterpret" && echo "$1" | grep -f "exec.skip" >/dev/null 2>&1; then
357 echo "=> $2: [skip exec]"
358 echo >>$xml "<testcase classname='`xmlesc "$3"`' name='`xmlesc "$2"`' `timestamp`><skipped/></testcase>"
359 return 0
360 fi
361
362 # Skip by OS
363 os_skip_file=`uname`.skip
364 if test -e $os_skip_file && echo "$1" | grep -f "$os_skip_file" >/dev/null 2>&1; then
365 echo "=> $2: [skip os]"
366 echo >>$xml "<testcase classname='`xmlesc "$3"`' name='`xmlesc "$2"`' `timestamp`><skipped/></testcase>"
367 return 0
368 fi
369 return 1
370 }
371
372 skip_exec()
373 {
374 test "$noskip" = true && return 1
375 if echo "$1" | grep -f "exec.skip" >/dev/null 2>&1; then
376 echo -n "_ "
377 return 0
378 fi
379 return 1
380 }
381
382 skip_cc()
383 {
384 test "$noskip" = true && return 1
385 if echo "$1" | grep -f "cc.skip" >/dev/null 2>&1; then
386 return 0
387 fi
388 return 1
389 }
390
391 find_nitc()
392 {
393 name="$enginebinname"
394 recent=`ls -t ../src/$name ../src/$name_[0-9] ../bin/$name ../c_src/$name 2>/dev/null | head -1`
395 if [[ "x$recent" == "x" ]]; then
396 echo "Could not find binary for engine $engine, aborting"
397 exit 1
398 fi
399 if [ "x$isnode" = "xfalse" ]; then
400 echo "Found binary for engine $engine: $recent $OPT"
401 fi
402 NITC=$recent
403 }
404
405 verbose=false
406 isnode=false
407 autosav=false
408 stop=false
409 engine=nitc
410 noskip=
411 savdirs=
412 while [ $stop = false ]; do
413 case $1 in
414 -o) OPT="$OPT $2"; shift; shift;;
415 -v) verbose=true; shift;;
416 -h) usage; exit;;
417 --engine) engine="$2"; shift; shift;;
418 --noskip) noskip=true; shift;;
419 --outdir) outdir="$2"; shift; shift;;
420 --compdir) compdir="$2"; shift; shift;;
421 --node) isnode=true; shift;;
422 --autosav) autosav=true; shift;;
423 *) stop=true
424 esac
425 done
426 enginebinname=$engine
427 isinterpret=
428 case $engine in
429 nitc|nitg)
430 engine=nitg-s;
431 enginebinname=nitc;
432 OPT="--separate $OPT --compile-dir $compdir"
433 savdirs="sav/nitg-common/"
434 ;;
435 nitcs|nitg-s)
436 enginebinname=nitc;
437 OPT="--separate $OPT --compile-dir $compdir"
438 savdirs="sav/nitg-common/"
439 ;;
440 nitce|nitg-e)
441 enginebinname=nitc;
442 OPT="--erasure $OPT --compile-dir $compdir"
443 savdirs="sav/nitg-common/"
444 ;;
445 nitcsg|nitg-sg)
446 enginebinname=nitc;
447 OPT="--semi-global $OPT --compile-dir $compdir"
448 savdirs="sav/nitg-common/"
449 ;;
450 nitcg|nitg-g)
451 enginebinname=nitc;
452 OPT="--global $OPT --compile-dir $compdir"
453 savdirs="sav/nitg-common/"
454 ;;
455 nit)
456 engine=niti
457 isinterpret=true
458 ;;
459 niti)
460 enginebinname=nit
461 isinterpret=true
462 ;;
463 nitvm)
464 isinterpret=true
465 enginebinname=nit
466 OPT="--vm $OPT"
467 savdirs="sav/niti/"
468 ;;
469 emscripten)
470 enginebinname=nitc
471 OPT="-m emscripten_nodejs.nit --semi-global $OPT --compile-dir $compdir"
472 savdirs="sav/nitg-sg/"
473 ;;
474 nitc)
475 echo "disabled engine $engine"
476 exit 0
477 ;;
478 *)
479 echo "unknown engine $engine"
480 exit 1
481 ;;
482 esac
483
484 savdirs="sav/$engine $savdirs sav/"
485
486 # The default nitc compiler
487 [ -z "$NITC" ] && find_nitc
488
489 # Set NIT_DIR if needed
490 [ -z "$NIT_DIR" ] && export NIT_DIR=..
491
492 # Mark to distinguish files among tests
493 # MARK=
494
495 if [ $# = 0 ]; then
496 usage;
497 exit
498 fi
499
500 # CLEAN the out directory
501 rm -rf "$outdir/" 2>/dev/null
502 mkdir "$outdir" 2>/dev/null
503
504 # File where error tests are outputed
505 # Old ERRLIST is backuped
506 ERRLIST=${ERRLIST:-errlist}
507 ERRLIST_TARGET=$ERRLIST
508
509 # Initiate new ERRLIST
510 if [ "x$ERRLIST" = "x" ]; then
511 ERRLIST=/dev/null
512 else
513 ERRLIST=$ERRLIST.tmp
514 > "$ERRLIST"
515 fi
516
517 ok=""
518 nok=""
519 todos=""
520
521 if [ "x$XMLDIR" = "x" ]; then
522 xml="tests-$engine.xml"
523 else
524 sum=`echo $@ | md5sum | cut -f1 -d " "`
525 xml="$XMLDIR/tests-$engine-$sum.xml"
526 mkdir -p "$XMLDIR"
527 fi
528
529 echo >$xml "<testsuites><testsuite>"
530
531 for ii in "$@"; do
532 if [ ! -f "$ii" ]; then
533 echo "File '$ii' does not exist."
534 continue
535 fi
536 f=`basename -- "$ii" .nit`
537
538 pack="tests.${engine}".`echo $ii | perl -p -e 's|^../([^/]*)/([a-zA-Z_]*).*|\1.\2| || s|^([a-zA-Z]*)[^_]*_([a-zA-Z]*).*|\1.\2| || s|\W*([a-zA-Z_]*).*|\1|'`
539
540 # Sould we skip the file for this engine?
541 need_skip "$f" "$f" "$pack" && continue
542
543 tmp=${ii/../AA}
544 if [ "x$tmp" = "x$ii" ]; then
545 includes="-I . -I ../lib/standard -I ../lib/standard/collection -I alt"
546 else
547 includes="-I alt"
548 fi
549
550 for i in "$ii" `./alterner.pl --start '#' --altsep '_' -- "$ii"`; do
551 bf=`basename -- "$i" .nit`
552 ff="$outdir/$bf"
553
554 # Sould we skip the alternative for this engine?
555 need_skip "$bf" "$bf" "$pack" && continue
556
557 echo -n "=> $bf: "
558
559 if [ -f "$f.inputs" ]; then
560 inputs="$f.inputs"
561 export MNIT_READ_INPUT="$f.inputs"
562 else
563 inputs=/dev/null
564 export MNIT_READ_INPUT=/dev/null
565 fi
566
567 ffout="$ff.bin"
568 if [ "$engine" = "emscripten" ]; then
569 ffout="$ff.bin.js"
570 fi
571
572 if [ -n "$isinterpret" ]; then
573 cat > "$ff.bin" <<END
574 exec $NITC --no-color $OPT $includes -- $(printf '%q' "$i") "\$@"
575 END
576 chmod +x "$ff.bin"
577 > "$ff.cmp.err"
578 > "$ff.compile.log"
579 ERR=0
580 echo 0.0 > "$ff.time.out"
581 else
582 if skip_cc "$bf"; then
583 nocc="--no-cc"
584 else
585 nocc=
586 fi
587 # Compile
588 if [ "x$verbose" = "xtrue" ]; then
589 echo ""
590 echo $NITC --no-color $OPT -o "$ffout" "$includes" $nocc "$i"
591 fi
592 NIT_NO_STACK=1 JNI_LIB_PATH=$JNI_LIB_PATH JAVA_HOME=$JAVA_HOME \
593 saferun -o "$ff.time.out" $NITC --no-color $OPT -o "$ffout" $includes $nocc "$i" 2> "$ff.cmp.err" > "$ff.compile.log"
594 ERR=$?
595 if [ "x$verbose" = "xtrue" ]; then
596 cat -- "$ff.compile.log"
597 cat >&2 -- "$ff.cmp.err"
598 fi
599 # Clean
600 rm -r "$compdir" 2>/dev/null
601 fi
602 if [ "$engine" = "emscripten" ]; then
603 echo > "$ff.bin" "nodejs $ffout \"\$@\""
604 chmod +x "$ff.bin"
605 if grep "Fatal Error: more than one primitive class" "$ff.compile.log" > /dev/null; then
606 echo " [skip] do no not imports kernel"
607 echo >>$xml "<testcase classname='`xmlesc "$pack"`' name='`xmlesc "$bf"`' `timestamp`><skipped/></testcase>"
608 continue
609 fi
610 fi
611 if [ "$ERR" != 0 ]; then
612 echo -n "! "
613 cat -- "$ff.compile.log" "$ff.cmp.err" > "$ff.res"
614 process_result "$bf" "$bf" "$pack"
615 elif [ -n "$nocc" ]; then
616 # not compiled
617 echo -n "nocc "
618 > "$ff.res"
619 process_result "$bf" "$bf" "$pack"
620 elif [ -x "$ff.bin" ]; then
621 if skip_exec "$bf"; then
622 # No exec
623 > "$ff.res"
624 process_result "$bf" "$bf" "$pack"
625 break
626 fi
627 echo -n ". "
628 # Execute
629 args=""
630 if [ "x$verbose" = "xtrue" ]; then
631 echo ""
632 echo "NIT_NO_STACK=1 $ff.bin" $args
633 fi
634 NIT_NO_STACK=1 LD_LIBRARY_PATH=$JNI_LIB_PATH \
635 saferun -a -o "$ff.time.out" "$ff.bin" $args < "$inputs" > "$ff.res" 2>"$ff.err"
636 mv "$ff.time.out" "$ff.times.out"
637 awk '{ SUM += $1} END { print SUM }' "$ff.times.out" > "$ff.time.out"
638
639 if [ "x$verbose" = "xtrue" ]; then
640 cat -- "$ff.res"
641 cat >&2 -- "$ff.err"
642 fi
643 if [ -f "$ff.write" ]; then
644 cat -- "$ff.write" >> "$ff.res"
645 elif [ -d "$ff.write" ]; then
646 LANG=C /bin/ls -F "$ff.write" >> "$ff.res"
647 fi
648 cp -- "$ff.res" "$ff.res2"
649 cat -- "$ff.cmp.err" "$ff.err" "$ff.res2" > "$ff.res"
650 process_result "$bf" "$bf" "$pack"
651
652 if [ -f "$f.args" ]; then
653 fargs=$f.args
654 cptr=0
655 while read line; do
656 ((cptr=cptr+1))
657 args="$line"
658 bff=$bf"_args"$cptr
659 fff=$ff"_args"$cptr
660 name="$bf args $cptr"
661
662 # Sould we skip the input for this engine?
663 need_skip "$bff" " $name" "$pack" && continue
664
665 # use a specific inputs file, if required
666 if [ -f "$bff.inputs" ]; then
667 ffinputs="$bff.inputs"
668 else
669 ffinputs="$inputs"
670 fi
671
672 rm -rf "$fff.res" "$fff.err" "$fff.write" 2> /dev/null
673 if [ "x$verbose" = "xtrue" ]; then
674 echo ""
675 echo "NIT_NO_STACK=1 $ff.bin" $args
676 fi
677 echo -n "==> $name "
678 echo "$ff.bin $args" > "$fff.bin"
679 chmod +x "$fff.bin"
680 WRITE="$fff.write" saferun -o "$fff.time.out" sh -c "NIT_NO_STACK=1 $fff.bin < $ffinputs > $fff.res 2>$fff.err"
681 if [ "x$verbose" = "xtrue" ]; then
682 cat -- "$fff.res"
683 cat >&2 -- "$fff.err"
684 fi
685 if [ -f "$fff.write" ]; then
686 cat -- "$fff.write" >> "$fff.res"
687 elif [ -d "$fff.write" ]; then
688 LANG=C /bin/ls -F -- "$fff.write" >> "$fff.res"
689 fi
690 if [ -s "$fff.err" ]; then
691 cp -- "$fff.res" "$fff.res2"
692 cat -- "$fff.err" "$fff.res2" > "$fff.res"
693 fi
694 process_result "$bff" " $name" "$pack"
695 done < "$fargs"
696 fi
697 elif [ -f "$ff.bin" ]; then
698 #Not executable (platform?)"
699 > "$ff.res"
700 process_result "$bf" "$bf" "$pack"
701 else
702 echo -n "! "
703 cat -- "$ff.cmp.err" > "$ff.res"
704 echo "Compilation error" > "$ff.res"
705 process_result "$bf" "$bf" "$pack"
706 fi
707 done
708 done
709
710 if [ "x$isnode" = "xfalse" ]; then
711 echo "engine: $engine ($enginebinname $OPT)"
712 echo "ok: " `echo $ok | wc -w` "/" `echo $ok $nok $nos $todos | wc -w`
713
714 if [ -n "$nok" ]; then
715 echo "fail: $nok"
716 echo "There were $(echo $nok | wc -w) errors ! (see file $ERRLIST)"
717 fi
718 if [ -n "$nos" ]; then
719 echo "no sav: $nos"
720 fi
721 if [ -n "$todos" ]; then
722 echo "todo/fixme: $todos"
723 fi
724 if [ -n "$remains" ]; then
725 echo "sav that remains: $remains"
726 fi
727 fi
728
729 # write $ERRLIST
730 if [ "x$ERRLIST" != "x" ]; then
731 if [ -f "$ERRLIST_TARGET" ]; then
732 mv "$ERRLIST_TARGET" "${ERRLIST_TARGET}.bak"
733 fi
734 uniq $ERRLIST > $ERRLIST_TARGET
735 rm $ERRLIST
736 fi
737
738 echo >>$xml "</testsuite></testsuites>"
739
740 if [ -n "$nok" ]; then
741 exit 1
742 else
743 exit 0
744 fi